// headers is a package for internal micro global constants
package headers

const (
	// Message header is a header for internal message communication.
	Message = "Micro-Topic"
	// Request header is a message header for internal request communication.
	Request = "Micro-Service"
	// Error header contains an error message.
	Error = "Micro-Error"
	// Endpoint header.
	Endpoint = "Micro-Endpoint"
	// Method header.
	Method = "Micro-Method"
	// ID header.
	ID = "Micro-ID"
	// Prefix used to prefix headers.
	Prefix = "Micro-"
	// Namespace header.
	Namespace = "Micro-Namespace"
	// Protocol header.
	Protocol = "Micro-Protocol"
	// Target header.
	Target = "Micro-Target"
	// ContentType header.
	ContentType = "Content-Type"
	// SpanID header.
	SpanID = "Micro-Span-ID"
	// TraceIDKey header.
	TraceIDKey = "Micro-Trace-ID"
	// Stream header.
	Stream = "Micro-Stream"
)
